Package lxml :: Module ElementInclude

[hide private]
[frames] | no frames]

# Source Code for Module lxml.ElementInclude

      1  #
      2  # ElementTree
      3  # $Id: ElementInclude.py 1862 2004-06-18 07:31:02Z Fredrik $
      4  #
      5  # limited xinclude support for element trees
      6  #
      7  # history:
      8  # 2003-08-15 fl   created
      9  # 2003-11-14 fl   fixed default loader
     10  #
     11  # Copyright (c) 2003-2004 by Fredrik Lundh.  All rights reserved.
     12  #
     13  # fredrik@pythonware.com
     14  # http://www.pythonware.com
     15  #
     16  # --------------------------------------------------------------------
     17  # The ElementTree toolkit is
     18  #
     19  # Copyright (c) 1999-2004 by Fredrik Lundh
     20  #
     21  # By obtaining, using, and/or copying this software and/or its
     22  # associated documentation, you agree that you have read, understood,
     23  # and will comply with the following terms and conditions:
     24  #
     25  # Permission to use, copy, modify, and distribute this software and
     26  # its associated documentation for any purpose and without fee is
     27  # hereby granted, provided that the above copyright notice appears in
     28  # all copies, and that both that copyright notice and this permission
     29  # notice appear in supporting documentation, and that the name of
     30  # Secret Labs AB or the author not be used in advertising or publicity
     31  # pertaining to distribution of the software without specific, written
     32  # prior permission.
     33  #
     34  # SECRET LABS AB AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD
     35  # TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANT-
     36  # ABILITY AND FITNESS.  IN NO EVENT SHALL SECRET LABS AB OR THE AUTHOR
     37  # BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
     38  # DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
     39  # WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
     40  # ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
     41  # OF THIS SOFTWARE.
     42  # --------------------------------------------------------------------
     43
     44  """
     45  Limited XInclude support for the ElementTree package.
     46
     47  While lxml.etree has full support for XInclude (see
     48  `etree.ElementTree.xinclude()`), this module provides a simpler, pure
     49  Python, ElementTree compatible implementation that supports a simple
     50  form of custom URL resolvers.
     51  """
     52
     53  from lxml import etree
     54  import copy
     55  try:
     56      from urlparse import urljoin
     57      from urllib2 import urlopen
     58  except ImportError:
     59      # Python 3
     60      from urllib.parse import urljoin
     61      from urllib.request import urlopen
     62
     63  try:
     64      set
     65  except NameError:
     66      # Python 2.3
     67      from sets import Set as set
     68
     69  XINCLUDE = "{http://www.w3.org/2001/XInclude}"
     70
     71  XINCLUDE_INCLUDE = XINCLUDE + "include"
     72  XINCLUDE_FALLBACK = XINCLUDE + "fallback"
     73
     74  ##
     75  # Fatal include error.
     76
     77 -class FatalIncludeError(etree.LxmlSyntaxError):
     78      pass
     79
     80  ##
     81  # ET compatible default loader.
     82  # This loader reads an included resource from disk.
     83  #
     84  # @param href Resource reference.
     85  # @param parse Parse mode.  Either "xml" or "text".
     86  # @param encoding Optional text encoding.
     87  # @return The expanded resource.  If the parse mode is "xml", this
     88  #    is an ElementTree instance.  If the parse mode is "text", this
     89  #    is a Unicode string.  If the loader fails, it can return None
     90  #    or raise an IOError exception.
     91  # @throws IOError If the loader fails to load the resource.
     92
     93 -def default_loader(href, parse, encoding=None):
     94      file = open(href, 'rb')
     95      if parse == "xml":
     96          data = etree.parse(file).getroot()
     97      else:
     98          data = file.read()
     99          if encoding:
    100              data = data.decode(encoding)
    101      file.close()
    102      return data
    103
    104  ##
    105  # Default loader used by lxml.etree - handles custom resolvers properly
    106  #
    107
    108 -def _lxml_default_loader(href, parse, encoding=None, parser=None):
    109      if parse == "xml":
    110          data = etree.parse(href, parser).getroot()
    111      else:
    112          if "://" in href:
    113              f = urlopen(href)
    114          else:
    115              f = open(href, 'rb')
    116          data = f.read()
    117          f.close()
    118          if encoding:
    119              data = data.decode(encoding)
    120      return data
    121
    122  ##
    123  # Wrapper for ET compatibility - drops the parser
    124
    125 -def _wrap_et_loader(loader):
    126      def load(href, parse, encoding=None, parser=None):
    127          return loader(href, parse, encoding)
    128      return load
    129
    130
    131  ##
    132  # Expand XInclude directives.
    133  #
    134  # @param elem Root element.
    135  # @param loader Optional resource loader.  If omitted, it defaults
    136  #     to {@link default_loader}.  If given, it should be a callable
    137  #     that implements the same interface as <b>default_loader</b>.
    138  # @throws FatalIncludeError If the function fails to include a given
    139  #     resource, or if the tree contains malformed XInclude elements.
    140  # @throws IOError If the function fails to load a given resource.
    141  # @returns the node or its replacement if it was an XInclude node
    142
    143 -def include(elem, loader=None, base_url=None):
    144      if base_url is None:
    145          if hasattr(elem, 'getroot'):
    146              tree = elem
    147              elem = elem.getroot()
    148          else:
    149              tree = elem.getroottree()
    150          if hasattr(tree, 'docinfo'):
    151              base_url = tree.docinfo.URL
    152      elif hasattr(elem, 'getroot'):
    153          elem = elem.getroot()
    154      _include(elem, loader, base_url=base_url)
    155
    156 -def _include(elem, loader=None, _parent_hrefs=None, base_url=None):
    157      if loader is not None:
    158          load_include = _wrap_et_loader(loader)
    159      else:
    160          load_include = _lxml_default_loader
    161
    162      if _parent_hrefs is None:
    163          _parent_hrefs = set()
    164
    165      parser = elem.getroottree().parser
    166
    167      include_elements = list(
    168          elem.iter('{http://www.w3.org/2001/XInclude}*'))
    169
    170      for e in include_elements:
    171          if e.tag == XINCLUDE_INCLUDE:
    172              # process xinclude directive
    173              href = urljoin(base_url, e.get("href"))
    174              parse = e.get("parse", "xml")
    175              parent = e.getparent()
    176              if parse == "xml":
    177                  if href in _parent_hrefs:
    178                      raise FatalIncludeError(
    179                          "recursive include of %r detected" % href
    180                          )
    181                  _parent_hrefs.add(href)
    182                  node = load_include(href, parse, parser=parser)
    183                  if node is None:
    184                      raise FatalIncludeError(
    185                          "cannot load %r as %r" % (href, parse)
    186                          )
    187                  node = _include(node, loader, _parent_hrefs)
    188                  if e.tail:
    189                      node.tail = (node.tail or "") + e.tail
    190                  if parent is None:
    191                      return node # replaced the root node!
    192                  parent.replace(e, node)
    193              elif parse == "text":
    194                  text = load_include(href, parse, encoding=e.get("encoding"))
    195                  if text is None:
    196                      raise FatalIncludeError(
    197                          "cannot load %r as %r" % (href, parse)
    198                          )
    199                  predecessor = e.getprevious()
    200                  if predecessor is not None:
    201                      predecessor.tail = (predecessor.tail or "") + text
    202                  elif parent is None:
    203                      return text # replaced the root node!
    204                  else:
    205                      parent.text = (parent.text or "") + text + (e.tail or "")
    206                  parent.remove(e)
    207              else:
    208                  raise FatalIncludeError(
    209                      "unknown parse type in xi:include tag (%r)" % parse
    210                  )
    211          elif e.tag == XINCLUDE_FALLBACK:
    212              parent = e.getparent()
    213              if parent is not None and parent.tag != XINCLUDE_INCLUDE:
    214                  raise FatalIncludeError(
    215                      "xi:fallback tag must be child of xi:include (%r)" % e.tag
    216                      )
    217          else:
    218              raise FatalIncludeError(
    219                  "Invalid element found in XInclude namespace (%r)" % e.tag
    220                  )
    221      return elem
    222